#ifndef __DOCRA_UTIL_HPP
#define __DOCRA_UTIL_HPP

#include <list>
#include <regex>
#include <string>

namespace docra { //docra``+

  static inline std::string trim_right_spaces(std::string &str)
  {
    size_t endpos = str.find_last_not_of(" \t\r\n");
    if(endpos != std::string::npos) {
      return str.substr(0, endpos + 1);
    }
    return str;
  }

  //`make_regex` Convert a pattern into a regex object
  std::regex make_regex(const std::string &pattern, bool ispath = false);//?>

  typedef std::pair<bool, std::regex> Filter;
  typedef std::list<Filter> Filters;

} //namespace docra

#endif//__DOCRA_UTIL_HPP
