#include "test.hpp"

typedef TestTmpFile<docra::Lexer_Ini> LexIniTmpFile;

TEST_F(LexIniTmpFile, Ini0) {
  wl("#comment");
  wl("[foo]");
  wl("bar=baz");
  wl("#comment");
  wl("");
  wl("[rebar]");
  wl("#another");
  ws("frob=42");
  we();

  CASSERT_CODE("", 0);
  CASSERT_COMM("comment\n", 0);
  CASSERT_CODE("[foo]\n", 0);
  CASSERT_CODE("bar=baz\n", 1);
  CASSERT_CODE("", 1);
  CASSERT_COMM("comment\n", 1);
  CASSERT_CODE("\n", 1);
  CASSERT_CODE("[rebar]\n", 0);
  CASSERT_CODE("", 0);
  CASSERT_COMM("another\n", 0);
  CASSERT_CODE("frob=42", 1);
  CASSERT_EOF();
}

TEST_F(LexIniTmpFile, IniRegmap0) {
  wl("#=regs.10g``");
  wl("# Plain comment");
  wl("[net]");
  wl("#+`net_`");
  wl("_addr_bits = 8");
  wl("#? First group of registers: <?");
  wl("off_rwtest = 0x00");
  wl("#+`off_rwtest` (RW) A register to test read/write access");
  wl("off_version = 0x04");
  wl("#+`off_version` (RO) Current version of this component");
  wl("off_phy_ready = 0x08");
  wl("#+`off_phy_ready` (RO) Bitset of:");
  wl("#? - 0: phy_tx_ready");
  wl("#? - 1: phy_rx_ready");
  wl("#? - 16..31: phy_rx_data_ready(link)");
  wl("#?>");
  wl("");
  wl("[link]");
  wl("#+`link_`");
  wl("_addr_bits = 8");
  wl("#? Another group of registers: <?");
  wl("off_mac_rx_ready = 0x00");
  wl("off_mac_rx_status_hi = 0x04");
  wl("off_mac_rx_status_lo = 0x08");
  wl("#?>");
  we();

  TASSERT_CODE("");
  TASSERT_TAG("=regs.10g", "", "");
  TASSERT_CODE("");
  TASSERT_STR(" Plain comment");
  TASSERT_SIN();
  TASSERT_CODE("[net]");
  TASSERT_CODE("");
  TASSERT_TAG("+", "net_", "");
  TASSERT_SIN();
  TASSERT_CODE("_addr_bits = 8");
  TASSERT_CODE("");
  TASSERT_STR("? First group of registers: ");
  TASSERT_BIN();
  TASSERT_CODE("off_rwtest = 0x00");
  TASSERT_CODE("");
  TASSERT_TAG("+", "off_rwtest", "");
  TASSERT_STR(" (RW) A register to test read/write access");
  TASSERT_CODE("off_version = 0x04");
  TASSERT_CODE("");
  TASSERT_TAG("+", "off_version", "");
  TASSERT_STR(" (RO) Current version of this component");
  TASSERT_CODE("off_phy_ready = 0x08");
  TASSERT_CODE("");
  TASSERT_TAG("+", "off_phy_ready", "");
  TASSERT_STR(" (RO) Bitset of:");
  TASSERT_CODE("");
  TASSERT_STR("? - 0: phy_tx_ready");
  TASSERT_CODE("");
  TASSERT_STR("? - 1: phy_rx_ready");
  TASSERT_CODE("");
  TASSERT_STR("? - 16..31: phy_rx_data_ready(link)");
  TASSERT_CODE("");
  TASSERT_BOUT();
  TASSERT_CODE("");
  TASSERT_SOUT();
  TASSERT_CODE("[link]");
  TASSERT_CODE("");
  TASSERT_TAG("+", "link_", "");
  TASSERT_SIN();
  TASSERT_CODE("_addr_bits = 8");
  TASSERT_CODE("");
  TASSERT_STR("? Another group of registers: ");
  TASSERT_BIN();
  TASSERT_CODE("off_mac_rx_ready = 0x00");
  TASSERT_CODE("off_mac_rx_status_hi = 0x04");
  TASSERT_CODE("off_mac_rx_status_lo = 0x08");
  TASSERT_CODE("");
  TASSERT_BOUT();
  TASSERT_SOUT();
  TASSERT_SOUT();
  TASSERT_EOF();
}
