#include <gtest/gtest.h>
#include "util.hpp"

TEST(MatchRegex, 01) {
  EXPECT_TRUE(std::regex_match("abc", docra::make_regex("$[a-c]*", true)));
}

TEST(MatchRegex, 02) {
  EXPECT_TRUE(std::regex_match(".docra", docra::make_regex("$^.*/?[.]docra$", true)));
}

TEST(MatchRegex, 03) {
#ifdef _WIN32
  EXPECT_TRUE(std::regex_match("foo\\bar\\CMakeLists.txt", docra::make_regex("$^.*/?CMakeLists[.]txt$", true)));
#else
  EXPECT_TRUE(std::regex_match("foo/bar/CMakeLists.txt", docra::make_regex("$^.*/?CMakeLists[.]txt$", true)));
#endif
}

TEST(MatchRegex, 04) {
#ifdef _WIN32
  EXPECT_TRUE(std::regex_match(".git\\", docra::make_regex(".git/", true)));
  EXPECT_TRUE(std::regex_match("foo/.git\\", docra::make_regex("$^.*/?[.]git/$", true)));
#else
  EXPECT_TRUE(std::regex_match(".git/", docra::make_regex(".git/", true)));
  EXPECT_TRUE(std::regex_match("foo/.git/", docra::make_regex("$^.*/?[.]git/$", true)));
#endif
}

TEST(MatchGlob, 01) {
  EXPECT_TRUE(std::regex_match("abc", docra::make_regex("abc", true)));
}

TEST(MatchGlob, 02) {
  EXPECT_TRUE(std::regex_match("file.txt", docra::make_regex("*.txt", true)));
}

TEST(MatchGlob, 03) {
  EXPECT_TRUE(std::regex_match("fail.txt", docra::make_regex("f??l.txt", true)));
}
